"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = MDXContent;

var _react = _interopRequireDefault(require("react"));

var _react2 = require("@mdx-js/react");

var _ui = require("@teambit/ui.mdx-scope-context");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var layoutProps = {};
var MDXLayout = "wrapper";

function MDXContent(_ref) {
  var components = _ref.components,
      props = _objectWithoutProperties(_ref, ["components"]);

  return (0, _react2.mdx)(MDXLayout, _extends({}, layoutProps, props, {
    components: components,
    mdxType: "MDXLayout"
  }), (0, _react2.mdx)(_ui.MDXScopeProvider, {
    components: {},
    mdxType: "MDXScopeProvider"
  }, (0, _react2.mdx)("p", null, "The ", (0, _react2.mdx)("a", {
    parentName: "p",
    "href": "https://bit.dev/teambit/dependencies/dependency-resolver"
  }, "Dependency Resolver"), " configures and installs dependencies for components in a Bit workspace. It auto-generates the dependency graph for components to spare us the tedious work of manually configuring it ourselves.\nIt does so by integrating the dependency policies set by various Bit extensions (primarily the workspace) with the components' parsed and analyzed ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "import"), "/", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "require"), " statements.\nIn addition to that, the Dependency Resolver offers an efficient API to manually modify the generated graph using policies that can be applied on groups of components."), (0, _react2.mdx)("h4", null, "Features"), (0, _react2.mdx)("ul", null, (0, _react2.mdx)("li", {
    parentName: "ul"
  }, (0, _react2.mdx)("p", {
    parentName: "li"
  }, (0, _react2.mdx)("strong", {
    parentName: "p"
  }, "Auto-generated dependency graph"), ":\nThe Dependency Resolver saves us time and effort by generating the dependency graph for each component handled by the workspace. It does so by parsing out all ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "import"), " \\ ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "require"), " statements in the component's files.\nIt then determines if these dependencies are packages, components or internal implementation files.\nIf they are external components or packages, it goes on to determine their version and dependency-type (", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "dependencies"), ", ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "devDependencies"), ", ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "peerDependencies"), ").")), (0, _react2.mdx)("li", {
    parentName: "ul"
  }, (0, _react2.mdx)("p", {
    parentName: "li"
  }, (0, _react2.mdx)("strong", {
    parentName: "p"
  }, "An efficient dependency configuration API:"), "\nThe Dependency Resolver strikes the right balance between automation and customization by offering a simple and efficient configuration API.\nUse it in the workspace configuration file to manually modify the version and dependency type of dependencies in the generated dependency graph.\nWhen used in combination with ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "@teambit.workspace/variant"), " it allows to define, in a cascading (CSS-like) way,\ndifferent dependency policies for different sets of components, and even to add or remove dependencies altogether.")), (0, _react2.mdx)("li", {
    parentName: "ul"
  }, (0, _react2.mdx)("p", {
    parentName: "li"
  }, (0, _react2.mdx)("strong", {
    parentName: "p"
  }, "Optimized dependency installation:"), "\nThe Dependency Resolver directs the package manager to install the correct packages in the correct location in the workspace file structure.\nWhen a dependency appears in the workspace dependency graph more than once, the Resolver searches for a common version that satisfies ", (0, _react2.mdx)("em", {
    parentName: "p"
  }, "most"), " dependent\ncomponents and installs it at the workspace root directory, where it can be shared by all relevant components."), (0, _react2.mdx)("blockquote", {
    parentName: "li"
  }, (0, _react2.mdx)("p", {
    parentName: "blockquote"
  }, "dependency versions that are used by a minority of components will be installed in each component's directory."))), (0, _react2.mdx)("li", {
    parentName: "ul"
  }, (0, _react2.mdx)("p", {
    parentName: "li"
  }, (0, _react2.mdx)("strong", {
    parentName: "p"
  }, "A single 'install command for packages and components:"), "\nA single ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "bit install"), " command will not only install packages but will also import components listed in your ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, ".bitmap"), " file.\nThese components will then be linked to your ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "node_modules"), " directory, to keep the same import pattern for both module types, components and packages.")), (0, _react2.mdx)("li", {
    parentName: "ul"
  }, (0, _react2.mdx)("p", {
    parentName: "li"
  }, (0, _react2.mdx)("strong", {
    parentName: "p"
  }, "Programmatic API for extensions and environments"), "\nThe Dependency Resolver provides other extensions and environments with an API that allows them to register their own dependency policies.\nFor example, the 'React environment' uses the Dependency Resolver to set 'react-dom' as a peerDependency for all components using it (in case a component author had either left ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "react-dom"), " out of its dependencies, or even registered it as a regular dependency)."))), (0, _react2.mdx)("h2", null, "Quickstart & configuration"), (0, _react2.mdx)("h3", null, "Auto-registered dependency version and type"), (0, _react2.mdx)("p", null, "Dependency policies define the version and dependency type of each package used by components in the workspace.\nWhen installing a package, the Dependency Resolver registers its version in the dependency configuration (if a version is not specified upon installation, it will default to the latest one)."), (0, _react2.mdx)("pre", null, (0, _react2.mdx)("code", {
    parentName: "pre",
    "className": "language-json"
  }, "// At the root-level of the workspace configuration JSON\n{\n  \"@teambit.dependencies/dependency-resolver\": {\n    \"policy\": {\n      \"dependencies\": {\n        \"lodash\": \"4.17.0\"\n      }\n    }\n  }\n}\n")), (0, _react2.mdx)("h2", null, "The dependency policies hierarchy"), (0, _react2.mdx)("p", null, "The Dependency Resolver integrates dependency policies from various sources to determine the component's final dependency graph.\nCases of conflicting policies are resolved according to a hierarchy of source types, where a 'higher' rule in the list overrides lower rules."), (0, _react2.mdx)("p", null, "The hierarchy in a descending order:"), (0, _react2.mdx)("ol", null, (0, _react2.mdx)("li", {
    parentName: "ol"
  }, "Policies set by Variants (", (0, _react2.mdx)("inlineCode", {
    parentName: "li"
  }, "@teambit/variants"), ") and the ", (0, _react2.mdx)("inlineCode", {
    parentName: "li"
  }, "component.json"), " files of \"ejected\" components (these two sources are merged by Variants)."), (0, _react2.mdx)("li", {
    parentName: "ol"
  }, "Policies set by various extensions/aspects (using ", (0, _react2.mdx)("inlineCode", {
    parentName: "li"
  }, "registerDependencyPolicy"), ")"), (0, _react2.mdx)("li", {
    parentName: "ol"
  }, "Policies set by the environment (using ", (0, _react2.mdx)("inlineCode", {
    parentName: "li"
  }, "getDependencies"), ")"), (0, _react2.mdx)("li", {
    parentName: "ol"
  }, "Bit\u2019s automated dependency detections, and policies set by the Dependency Resolver at the workspace configuration root-level.")), (0, _react2.mdx)("blockquote", null, (0, _react2.mdx)("p", {
    parentName: "blockquote"
  }, "Use the ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "bit dependencies <component-id>"), " command to understand the calculations and interactions which resolved to the generated dependency graph of a specific component.")), (0, _react2.mdx)("h3", null, "Select a package manager"), (0, _react2.mdx)("p", null, "The Dependency resolver does not replace package managers - it uses them and directs them.\nTo choose between 'Yarn' and 'pnpm', set the ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "packageManager"), " property to either of the following:"), (0, _react2.mdx)("ul", null, (0, _react2.mdx)("li", {
    parentName: "ul"
  }, (0, _react2.mdx)("inlineCode", {
    parentName: "li"
  }, "teambit.dependencies/yarn")), (0, _react2.mdx)("li", {
    parentName: "ul"
  }, (0, _react2.mdx)("inlineCode", {
    parentName: "li"
  }, "teambit.dependencies/pnpm"))), (0, _react2.mdx)("pre", null, (0, _react2.mdx)("code", {
    parentName: "pre",
    "className": "language-json"
  }, "// At the root-level of the workspace configuration JSON\n{\n  \"teambit.dependencies/dependency-resolver\": {\n    \"packageManager\": \"teambit.dependencies/yarn\"\n  }\n}\n")), (0, _react2.mdx)("h3", null, "Apply policies on all relevant components"), (0, _react2.mdx)("p", null, "A dependency policy configured at the root level of the workspace configuration (JSON) will by default affect ", (0, _react2.mdx)("em", {
    parentName: "p"
  }, "all"), " components that have that package as their dependency (i.e., components that have this module listed in their generated dependency graph).\n", (0, _react2.mdx)("strong", {
    parentName: "p"
  }, "Components that do not have this package as a dependency will not be affected.")), (0, _react2.mdx)("p", null, "For example:"), (0, _react2.mdx)("pre", null, (0, _react2.mdx)("code", {
    parentName: "pre",
    "className": "language-json"
  }, "// At the root-level of the workspace configuration JSON\n\n// Every component in the workspace that has 'lodash' as a dependency will version '3.0.0'.\n// This policy will not affect any component that does not have 'lodash' as a dependency.\n\n{\n  \"teambit.dependencies/dependency-resolver\": {\n    \"policy\": {\n      \"dependencies\": {\n        \"lodash\": \"3.0.0\"\n      }\n    }\n  }\n}\n")), (0, _react2.mdx)("h3", null, "Apply policies on a selected group of components"), (0, _react2.mdx)("p", null, "Dependency policies can be applied on a specific group of components. This is done using the ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "@teambit.workspace/variants"), " configuration API."), (0, _react2.mdx)("p", null, "For example, to set version ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "1.0.0"), " of ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "classnames"), " as a dependency of all components located inside the ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "./components/react"), " directory (or any of its sub-directories):"), (0, _react2.mdx)("pre", null, (0, _react2.mdx)("code", {
    parentName: "pre",
    "className": "language-json"
  }, "{\n  \"teambit.workspace/variants\": {\n    \"components/react\": {\n      // this creates a variant for all components contained in the components/react directory and it's sub-directories\n      \"teambit.dependencies/dependency-resolver\": {\n        // this creates dependencies overrides for the current variant\n        \"policy\": {\n          \"dependencies\": {\n            \"classnames\": \"1.0.0\"\n          }\n        }\n      }\n    }\n  }\n}\n")), (0, _react2.mdx)("h3", null, "Remove a dependency"), (0, _react2.mdx)("p", null, "Dependency policies can also be used to move or remove a dependency. That's especially useful when a dependency is defined with an incorrect dependency type.\nFor example, a module can be \"moved\" from ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "dependencies"), " to ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "peerDependencies"), " by removing it from ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "dependencies"), " and listing it under ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "peerDependencies"), "."), (0, _react2.mdx)("pre", null, (0, _react2.mdx)("code", {
    parentName: "pre",
    "className": "language-json"
  }, "  \"teambit.dependencies/dependency-resolver\": {\n    \"policy\": {\n      \"dependencies\": {\n        \"enzyme\": \"-\"\n      },\n      \"peerDependencies\": {\n        \"enzyme\": \"^3.11.0\"\n      }\n    }\n")), (0, _react2.mdx)("h3", null, "Override cascading policies"), (0, _react2.mdx)("p", null, "Policies set on a specific group of components will override any conflicting policies that have cascaded from more general configurations."), (0, _react2.mdx)("p", null, "For example, the following configuration will set ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "classnames"), " version ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "1.0.0"), " on all components using the ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "react-ui"), " namespace. This policy will override the workspace-level policy that uses version ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "2.0.0"), " of that same package."), (0, _react2.mdx)("pre", null, (0, _react2.mdx)("code", {
    parentName: "pre",
    "className": "language-json"
  }, "// All components using the namespace 'react-ui' will use version 1.0.0 of \"classnames\"\n// instead of version \"2.0.0\" which is set as the more general default for all components in the workspace\n{\n  \"teambit.workspace/workspace\": {\n    \"name\": \"my-workspace\"\n  },\n  \"teambit.dependencies/dependency-resolver\": {\n    \"policy\": {\n      \"dependencies\": {\n        \"classnames\": \"2.0.0\"\n      }\n    }\n  },\n  \"teambit.workspace/variants\": {\n    \"{react-ui/*}\": {\n      // the {} notation sets the variant grouping via namespace, so in this case any (/*) components whose namespace begins with 'react-ui'\n      \"teambit.dependencies/dependency-resolver\": {\n        \"policy\": {\n          \"classnames\": \"1.0.0\"\n        }\n      }\n    }\n  }\n}\n")), (0, _react2.mdx)("h3", null, "\"Forcibly\" add dependencies to a component"), (0, _react2.mdx)("p", null, "Dependency policies applied on a selected group of components will \"forcibly\" add the listed packages to any ", "[selected]", " component for whom the Dependency Resolved has not already identified that package as a dependency.\nThis can be useful when a component depends on another module but has no ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "import"), "/", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "require"), " statement to be parsed by the Dependency Resolver (for example, in a Webpack configuration file, or as a peerDependency of a consumed package)."), (0, _react2.mdx)("p", null, "In the following example, ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "classnames@1.0.0"), " will be \"forcibly\" added as a dependency to any component using the ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "react-ui"), " namespace."), (0, _react2.mdx)("pre", null, (0, _react2.mdx)("code", {
    parentName: "pre",
    "className": "language-json"
  }, "  \"teambit.workspace/variants\": {\n    \"{react-ui/*}\": {\n      \"teambit.dependencies/dependency-resolver\": {\n        \"policy\": {\n          \"classnames\": \"1.0.0\"\n        }\n      }\n    }\n  }\n")), (0, _react2.mdx)("h3", null, "Set dependency types"), (0, _react2.mdx)("h4", null, "dev dependencies"), (0, _react2.mdx)("p", null, "Dev dependencies are determined by the type of file in a component that uses the dependency.\nIf it is a development file (e.g, ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "doSomething.test.ts"), ") then the packages consumed by it are also considered\nto be used for development and will therefore be registered as ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "devDependencies"), ". In cases where a module is consumed by both a runtime file and a development file, the module will be considered as a runtime (regular) dependency."), (0, _react2.mdx)("blockquote", null, (0, _react2.mdx)("p", {
    parentName: "blockquote"
  }, (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "devDependencies"), " that are set by the Dependency Resolver will not be visible in the component's configuration. To validate that a dependency is registered as a dev dependency, use the ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "bit show <component>"), " command.")), (0, _react2.mdx)("p", null, "The list of file patterns to be considered as development files is determined by the various Bit extensions. For example, the ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "@teambit.react/react"), " environment lists all ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "*.spec.tsx"), " files as dev files.\nAny component using that environment will have its ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, ".spec.tsx"), " files considered as dev files and all these files' dependencies considered as ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "devDependencies"), "."), (0, _react2.mdx)("h5", null, "Register file patterns to be considered as dev files"), (0, _react2.mdx)("p", null, "Set the ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "devFilePatterns"), " property to add your own list of file extensions to be considered as development files (and to have all their dependencies considered as ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "devDependencies"), "):"), (0, _react2.mdx)("pre", null, (0, _react2.mdx)("code", {
    parentName: "pre",
    "className": "language-json"
  }, "// At the root-level of the workspace configuration JSON\n{\n  \"teambit.dependencies/dependency-resolver\": {\n    \"devFilePatterns\": [\".spec.ts\"]\n  }\n}\n")), (0, _react2.mdx)("h5", null, "Configure specific dependencies as devDependencies"), (0, _react2.mdx)("blockquote", null, (0, _react2.mdx)("p", {
    parentName: "blockquote"
  }, "Dependencies can be ", (0, _react2.mdx)("em", {
    parentName: "p"
  }, "directly"), " configured as ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "devDependencies"), " ", (0, _react2.mdx)("em", {
    parentName: "p"
  }, "only"), " via the ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "variants"), " config API.")), (0, _react2.mdx)("pre", null, (0, _react2.mdx)("code", {
    parentName: "pre",
    "className": "language-json"
  }, "{\n  \"teambit.workspace/variants\": {\n    \"*\": {\n      \"teambit.dependencies/dependency-resolver\": {\n        \"policy\": {\n          \"devDependencies\": {\n            \"react-test-renderer\": \"17.0.1\"\n          }\n        }\n      }\n    }\n  }\n}\n")), (0, _react2.mdx)("h4", null, "peer dependencies"), (0, _react2.mdx)("p", null, "Setting a package as a peer dependency ensures the package manager installs only a single version of that package. If that is not possible, i.e. if there is no single \u201Cagreed upon\u201D version for all components in the workspace, then an error will be thrown."), (0, _react2.mdx)("p", null, "This can be crucial when different components communicate with each other using shared objects that are instantiated by an installed package (the dependency). If different versions of the same package create different object instances then the \u201Cmeans of communication\u201D is broken. There is no single object to address, no single source of truth. This can turn out to be critical when working with modules that are used as \u201Cplugins\u201D of another module (for example, Babel), or when working with components that are coordinated in runtime using a shared library (for example, React)."), (0, _react2.mdx)("p", null, "To set a package as a peer dependency, place it under the ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "peerDependencies"), " entry, like so:"), (0, _react2.mdx)("pre", null, (0, _react2.mdx)("code", {
    parentName: "pre",
    "className": "language-json"
  }, "{\n  \"teambit.bit/dependency-resolver\": {\n    \"policy\": {\n      \"dependencies\": {},\n      \"peerDependencies\": {\n        \"react\": \"^16.13.1\",\n        \"react-dom\": \"^16.13.1\",\n      }\n    }\n}\n")), (0, _react2.mdx)("blockquote", null, (0, _react2.mdx)("p", {
    parentName: "blockquote"
  }, "Peer dependencies are usually used in the context of a single \"hosting code\". That could be an application or a single component library.\nBit may generate multiple \"hosts\", one for each environment being used, to run components of different types.\nThat could translate into multiple versions of the same peer dependency, one for each environment.")), (0, _react2.mdx)("h2", null, "Enforce the installation of a specific package version"), (0, _react2.mdx)("p", null, "The dependency resolver determines the package version that best fits the requirements of most components consuming the same package.\nIt then installs it at the root of the workspace to make it available to all components sharing the same package (those that cannot use it will have their dependency installed inside their own directory)."), (0, _react2.mdx)("p", null, "As a result, a package installed by the Dependency Resolver may not have the same version that was specified in the Dependency Resolver policy.\nTo enforce the installation of the exact version specified in the policy, set the ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "preserve"), " property to ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "true"), "."), (0, _react2.mdx)("pre", null, (0, _react2.mdx)("code", {
    parentName: "pre",
    "className": "language-json"
  }, "{\n  \"teambit.dependencies/dependency-resolver\": {\n    \"policy\": {\n      \"dependencies\": {\n        \"lodash\": {\n          \"version\": \"3.0.0\",\n          \"preserve\": true\n        }\n      }\n    }\n  }\n}\n")), (0, _react2.mdx)("h2", null, "Set a proxy for outgoing HTTP/HTTPS requests"), (0, _react2.mdx)("p", null, "The package manager can be configured to use a proxy for outgoing network requests."), (0, _react2.mdx)("p", null, (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "proxy"), " - A URL for a proxy to be used in both HTTP and HTTPS requests."), (0, _react2.mdx)("p", null, (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "httpsProxy"), " - A URL specific for HTTPS requests (this will override the value set in ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "proxy"), " for HTTPS requests)."), (0, _react2.mdx)("pre", null, (0, _react2.mdx)("code", {
    parentName: "pre",
    "className": "language-json"
  }, "{\n  \"teambit.dependencies/dependency-resolver\": {\n    \"proxy\": \"http://domain-one.proxy.com:8080\",\n    \"httpsProxy\": \"http://domain-two.proxy.com:8080\"\n  }\n}\n")), (0, _react2.mdx)("h5", null, "A proxy can also be set in NPM's and Bit's global configurations"), (0, _react2.mdx)("p", null, "To get the value for 'proxy'/'https-proxy':"), (0, _react2.mdx)("pre", null, (0, _react2.mdx)("code", {
    parentName: "pre",
    "className": "language-bash"
  }, "bit config get proxy\n\nbit config get https-proxy\n")), (0, _react2.mdx)("p", null, "To set a new 'proxy'/'https-proxy' value:"), (0, _react2.mdx)("pre", null, (0, _react2.mdx)("code", {
    parentName: "pre",
    "className": "language-bash"
  }, "bit config set proxy http://domain-one.proxy.com:8080\n\nbit config set https-proxy http://domain-one.proxy.com:8080\n")), (0, _react2.mdx)("p", null, "Read about setting a proxy in NPM's global configuration ", (0, _react2.mdx)("a", {
    parentName: "p",
    "href": "https://docs.npmjs.com/cli/v6/using-npm/config#https-proxy"
  }, "here")), (0, _react2.mdx)("blockquote", null, (0, _react2.mdx)("p", {
    parentName: "blockquote"
  }, "Notice the Dependency Resolver config will override ", (0, _react2.mdx)("em", {
    parentName: "p"
  }, "all"), " other proxy configurations. The NPM config will override Bit's global proxy configurations.")), (0, _react2.mdx)("h2", null, "CLI reference"), (0, _react2.mdx)("h3", null, "install"), (0, _react2.mdx)("blockquote", null, (0, _react2.mdx)("p", {
    parentName: "blockquote"
  }, "By default, the Dependency Resolver installs packages from Bit.dev's registry. The authentication for that registry is via your Bit.dev token, listed under ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "@bit"), ", in your ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, ".npmrc"), " file.\nIf that token cannot be found in the ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, ".npmrc"), " file, Bit will look for it in your global Bit configurations (use the ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "bit config"), " command to output your ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "user.token"), " property)."), (0, _react2.mdx)("br", null), "If your npm is configured to use a registry other than npmjs's, then the Dependency Resolver will use that configured registry, instead."), (0, _react2.mdx)("blockquote", null, (0, _react2.mdx)("p", {
    parentName: "blockquote"
  }, "The 'install' process includes importing components and linking them to the ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "node_modules"), " directory.")), (0, _react2.mdx)("h5", null, "Install all dependencies listed in the Dependency Resolver configuration:"), (0, _react2.mdx)("pre", null, (0, _react2.mdx)("code", {
    parentName: "pre",
    "className": "language-bash"
  }, "bit install\n")), (0, _react2.mdx)("h5", null, "Install the latest version of a package:"), (0, _react2.mdx)("pre", null, (0, _react2.mdx)("code", {
    parentName: "pre",
    "className": "language-bash"
  }, "bit install <package>\n\n// For example\nbit install lodash\n")), (0, _react2.mdx)("h5", null, "Install a specific version of a package:"), (0, _react2.mdx)("pre", null, (0, _react2.mdx)("code", {
    parentName: "pre",
    "className": "language-bash"
  }, "bit install <package>@<version>\n\n// For example\nbit install lodash@1.0.0\n")), (0, _react2.mdx)("h5", null, "Install packages that are already listed in the Dependency Resolver policies"), (0, _react2.mdx)("p", null, "When trying to install a specific package that is already listed in the Dependency Resolver policies, an error will be thrown."), (0, _react2.mdx)("p", null, "To override it:"), (0, _react2.mdx)("pre", null, (0, _react2.mdx)("code", {
    parentName: "pre",
    "className": "language-bash"
  }, "bit install <package> --update-existing\n\nbit install <package> -u\n")), (0, _react2.mdx)("h5", null, "Install packages without importing components"), (0, _react2.mdx)("p", null, "The 'install' process includes importing components listed in the ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, ".bitmap"), " file and linking them to the ", (0, _react2.mdx)("inlineCode", {
    parentName: "p"
  }, "node_modules"), " directory.\nTo disable importing and install all packages and components as standard packages use:"), (0, _react2.mdx)("pre", null, (0, _react2.mdx)("code", {
    parentName: "pre",
    "className": "language-bash"
  }, "bit install --skip-import\n"))));
}

;
MDXContent.isMDXComponent = true;

//# sourceMappingURL=dependency-resolver.mdx.js.map